<?php



// The only template in the file.

function template_main()

{

	global $context, $settings, $options, $scripturl, $txt;

	// Display the table header and linktree.

	echo '

	<div style="padding: 3px;">', theme_linktree(), '</div>';

	$brokendown = array (

		'Members' => array(),

		'Guests' => array(),

		'Spiders' => array(),

	);



	foreach($context['members'] AS $key => $member)

	{

		$spider = getAgent($member['query']['USER_AGENT'], $context['members'][$key]['name'], $agent, $member['id'] == 0);

		$context['members'][$key]['agent'] = $agent;

		$member['query']['USER_AGENT'] = isset($member['query']['USER_AGENT']) ? $member['query']['USER_AGENT'] : '';

		if ( $member['id'] != 0 )

			$brokendown['Members'][] = &$context['members'][$key];

		else if ( $spider )

			$brokendown['Spiders'][] = &$context['members'][$key];

		else

			$brokendown['Guests'][] = &$context['members'][$key];

	}

//	echo '<pre>'; print_r($brokendown['Spiders']); echo '</pre>'; return;

	foreach($brokendown AS $group => $members)

	{

		echo '

	<table cellpadding="3" cellspacing="0" border="0" width="100%" class="tborder">

		<tr>

			<td class="catbg">', $group, '</td>

		</tr>

	</table>

	<table cellpadding="3" cellspacing="0" border="0" width="100%" class="tborder">

		<tr class="titlebg">

			<td class="windowbg3 width="30%"><a href="' . $scripturl . '?action=who;sort=user', $context['sort_direction'] == 'down' && $context['sort_by'] == 'user' ? ';asc' : '', '">', $txt['who_user'], ' ', $context['sort_by'] == 'user' ? '<img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>

			<td class="windowbg3 style="width: 14ex;"><a href="' . $scripturl . '?action=who;sort=time', $context['sort_direction'] == 'down' && $context['sort_by'] == 'time' ? ';asc' : '', '">', $txt['who_time'], ' ', $context['sort_by'] == 'time' ? '<img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>

			<td class="windowbg3">', $txt['who_action'], '</td>

			<td class="windowbg3 style="width: 14ex;"><a href="' . $scripturl . '?action=who;sort=ip', $context['sort_direction'] == 'down' && $context['sort_by'] == 'ip' ? ';asc' : '', '">', $txt[512], ' ', $context['sort_by'] == 'ip' ? '<img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>

		</tr>';



		// This is used to alternate the color of the background.

		$alternate = true;



		// For every member display their name, time and action (and more for admin).

		foreach ($members as $member)

		{



			// $alternate will either be true or false.  If it's true, use "windowbg2" and otherwise use "windowbg".

			echo '

			<tr class="windowbg', $alternate ? '2' : '', '">

				<td>';



			// Guests don't have information like icq, msn, y!, and aim... and they can't be messaged.

			if (!$member['is_guest'])

			{

				echo '

					<div style="float: right; width: 14ex;">

						', $context['can_send_pm'] ? '<a href="' . $member['online']['href'] . '" title="' . $member['online']['label'] . '">' : '', $settings['use_image_buttons'] ? '<img src="' . $member['online']['image_href'] . '" alt="' . $member['online']['text'] . '" border="0" align="middle" />' : $member['online']['text'], $context['can_send_pm'] ? '</a>' : '', '

						', $member['icq']['link'], ' ', $member['msn']['link'], ' ', $member['yim']['link'], ' ', $member['aim']['link'], '

					</div>';

		}



		echo '

				<span', $member['is_hidden'] ? ' style="font-style: italic;"' : '', '>', $member['is_guest'] ? $member['name'] : '<a href="' . $member['href'] . '" title="' . $txt[92] . ' ' . $member['name'] . '"' . (empty($member['color']) ? '' : ' style="color: ' . $member['color'] . '"') . '>' . $member['name'] . '</a>', '</span>';

		echo '

			</td>

			<td nowrap="nowrap">', $member['time'], '</td>

			<td>', $member['action'], '</td>

			<td><a href="' . $scripturl . '?action=trackip;searchip=' . $member['ip'] . '" target="_blank" title="' . $member['ip'] . '" class="smalltext2">' . $member['ip'] . '</a></td>

		</tr>';
	   if ( !empty($member['ip']) ) {
                echo '<tr class="windowbg', $alternate ? '2' : '', '"><td colspan="4">';
    		echo '<span class="smalltext">';
		echo '<b><a href="' . $scripturl . '?action=trackip;searchip=' . $member['ip'] . '" target="_blank" title="' . $member['ip'] . '" class="smalltext2">' . $member['ip'] . '</a></b> (' . host_from_ip($member['ip'])  . '), <acronym title="' . $member['query']['USER_AGENT'] . '">' . $member['agent'] . '</acronym>';
 		echo '<br /> User agent: ' . $member['query']['USER_AGENT'];
//echo '<br />';
//print_r ($context);

                echo '</span>';
                echo '</td></tr>';

                 }

		// Switch alternate to whatever it wasn't this time. (true -> false -> true -> false, etc.)

		$alternate = !$alternate;

		}

		echo '</table><br/>';

	}

	echo '

	<table cellpadding="3" cellspacing="0" border="0" width="100%" class="tborder"><tr><td class="titlebg">

		<b>', $txt[139], ':</b> ', $context['page_index'], '

	</td></tr></table>';



}



function getAgent( &$user_agent, &$user_name, &$result, $guest )

{

	$known_agents = array (
		//Search Spiders
							array (
								'agent' => 'blank',
								'spidername' => 'blank',
								'spider' => true,
							 ),
							array (
								'agent' => 'blank',
								'spidername' => 'blank',
								'spider' => true,
							 ),
					                array (
									
								'agent' => 'Baiduspider',
									
								'spidername' => 'China Baidu.com spider',
									
								 'spider' => true,
									
							),
									
									
											
							array (
								'agent' => 'Microsoft URL Control',
								'spidername' => 'Microsoft URL Control',
							        'spider' => true,
											
							),
									
													
							array (
								'agent' => 'Sogou web spider/3.0',
								'spidername' => 'Sogou web spider/3.0',
							        'spider' => true,
													
							),
									
									
							array (
								'agent' => 'Internetseer',
								'spidername' => 'Internetseer',
							        'spider' => true,
															
							),
							array (
								'agent' => 'SurveyBot/2.3',
								'spidername' => 'SurveyBot',
							        'spider' => true,
								
							),
									
							array (
								'agent' => 'geniebot',
								'spidername' => 'GenieKnows',
								'spider' => true,
							),
							
							array (
								'agent' => 'msnbot-media/1.0',
								'spidername' => 'msnbot-media/1.0',
								'spider' => true,
							
							),
									
							array (
								'agent' => 'msnbot/1.0',
								'spidername' => 'msnbot/1.0',
								'spider' => true,
									
							),
							
							array (
								'agent' => 'IRLbot/3.0',
								'spidername' => 'IRLbot/3.0',
							        'spider' => true,
							),
							array (
								'agent' => 'blank',
								'spidername' => 'blank',
								'spider' => true,
							 ),
					                array (
								'agent' => 'Googlebot/2.1',
								'spidername' => 'Google Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'MSNBOT/0.xx',
								'spidername' => 'MSN Spider',
								'spider' => true,
					                ),
					
					                array (
								'agent' => 'msnbot-media/1.0',
								'spidername' => 'MSN Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'msnbot-Products/1.0',
								'spidername' => 'MSN Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'MSNPTC/1.0  ',
								'spidername' => 'MSN Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'SearchSight 2.0',
								'spidername' => 'SearchSight Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Sensis Web Crawler ',
								'spidername' => 'Sensis Web Crawler ',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Snappy 1.1',
								'spidername' => 'Snappy Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Websquash.com',
								'spidername' => 'WebSquash Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'YahooSeeker-Testing v3.9',
								'spidername' => 'Yahoo Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'YahooSeeker 1.2',
								'spidername' => 'Yahoo Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Scrubby 2.2',
								'spidername' => 'Scrub the Web Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Scrubby 2.1',
								'spidername' => 'Scrub the Web Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Googlebot-Image 1.0',
								'spidername' => 'Google Image Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Googlebot 2.1',
								'spidername' => 'Google Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Girafabot ',
								'spidername' => 'Girafabot ',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Gigabot 2.0',
								'spidername' => 'Gigablast spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Gigabot 1.0',
								'spidername' => 'Gigablast Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'genieBot',
								'spidername' => 'GenieKnows Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'FyberSpider',
								'spidername' => 'FyberSearch Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'FurlBot Furl Search 2.0',
								'spidername' => 'LookSmart Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'FAST-WebCrawler 3.8',
								'spidername' => 'Fast Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'FAST-WebCrawler 3.7',
								'spidername' => 'Fast Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'FAST-WebCrawler 3.6',
								'spidername' => 'Fast Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'FAST-WebCrawler 3.x',
								'spidername' => 'Fast Spyder',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Exabot 2.0',
								'spidername' => 'Exava Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'EsperanzaBot',
								'spidername' => 'Expranza Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'envolk[ITS]spider 1.6',
								'spidername' => 'envolk Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'EmeraldShield.com WebBot',
								'spidername' => 'EmeraldShield.com WebBot',
								'spider' => true,
					                ),
					                array (
								'agent' => 'DiamondBot',
								'spidername' => 'Claria Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'DataparkSearch 4.37',
								'spidername' => 'DataPark Search Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'DataparkSearch 4.36',
								'spidername' => 'DataPark Search Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'DataparkSearch 4.35',
								'spidername' => 'DataPark Search Spider',
								'spider' => true,
					                ),
					
					                array (
								'agent' => 'cosmos',
								'spidername' => 'xyleme Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'ConveraCrawler',
								'spidername' => 'Convera Crawler',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Cerberian Drtrs',
								'spidername' => 'Cerberian Drtrs',
								'spider' => true,
					                ),
					                array (
								'agent' => 'boitho.com-robot 1.1',
								'spidername' => 'Boitho Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'boitho.com-robot 1.0',
								'spidername' => 'Boitho Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'boitho.com-dc 0.79',
								'spidername' => 'Boitho Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'boitho.com-dc 0.81',
								'spidername' => 'Boitho Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'boitho.com-dc 0.82',
								'spidername' => 'Boitho Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'boitho.com-dc 0.83',
								'spidername' => 'Boitho Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'boitho.com-dc 0.85',
								'spidername' => 'Boitho Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Bimbot',
								'spidername' => 'Bimbot',
								'spider' => true,
					                ),
					                array (
								'agent' => 'BecomeBot',
								'spidername' => 'Become Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Arachmo',
								'spidername' => 'Arachmo',
								'spider' => true,
					                ),
					                array (
								'agent' => 'AnyApexBot',
								'spidername' => 'Any Apex Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Accoona-AI-Agent',
								'spidername' => 'Accoona Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'AbiLogicBot',
								'spidername' => 'AbiLogic Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'ABACHOBot',
								'spidername' => 'Abacho Spider',
								'spider' => true,
					                ),
					                array (
								'agent' => 'Pogodak.co.yu',
								'spidername' => 'Pogodak',
								'spider' => true,
							),
					                array (
					
								'agent' => 'TridentSpider',
								'spider' => true,
							),
					                array (
								'agent' => 'ccubee',
								'spider' => true,
							),
					                array (
								'agent' => 'Alcohol Search',
								'spider' => true,
							),
							array (
								'agent' => 'sogou spider',
								'spidername' => 'Sogou spider',
								'spider' => true,
							 ),
							array (
								'agent' => 'Twiceler',
								'spidername' => 'Twiceler spider',
								'spider' => true,
							 ),
					                 array (
								'agent' => 'www.fi crawler',
								'spidername' => 'www.fi spider',
								'spider' => true,
							 ),
							array (
					                        'agent' => 'WISENutbot',
					                        'spidername' => 'Looksmart spider',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'MSNBot',
					                        'spidername' => 'MSN spider',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'W3C_Validator',
					                        'spidername' => 'W3C Validator',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'Googlebot-Image',
					                        'spidername' => 'Google-Image spider',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'Googlebot',
					                        'spidername' => 'Google spider',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'appie',
					                        'spidername' => 'Walhello spider',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'Mediapartners-Google',
					                        'spidername' => 'Google AdSense spider',
					                        'spider' => true,
					                ),
					
					                array (
					                        'agent' => 'Scooter',
					                        'spidername' => 'Altavista spider',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'FAST-WebCrawler',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'Wget',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'Ask Jeeves', 
					                        'spider' => true,
					
					                ),
					                array (
					                        'agent' => 'Speedy Spider',
					                        'spider' => true,
					
					                ),
					                array (
					                        'agent' => 'SurveyBot',
					                        'spider' => true,
					
					                ),
					                array (
					                        'agent' => 'IBM_Planetwide',
					                       'spider' => true,
					                ),
					                array (
					                        'agent' => 'GigaBot',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'ia_archiver',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'FAST-WebCrawler',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'Yahoo! Slurp', 
					                        'spidername' => 'Yahoo spider',
					                        'spider' => true,
					                ),
					                array (
					                        'agent' => 'Inktomi Slurp',
					                        'spider' => true,
					                ),
							array (
								'agent' => 'appie',
								'spidername' => 'Walhello spider',
							),
							array (
					            'agent' => 'FeedBurner/1.0',
					            'spidername' => 'Feedburner',
							'spider' => true,
					        ),
					        array (
					            'agent' => 'Feedfetcher-Google',
					'spidername' => 'Googlen Feedfetcher',
					'spider' => true,
					        ),
					        array (
					            'agent' => 'OmniExplorer_Bot/6.68',
					            'spidername' => 'OmniExplorer Bot',
					'spider' => true,
					        ),
					        array (
					            'agent' => 'http://www.relevantnoise.com',
					            'spidername' => 'relevantNOISE',
					'spider' => true,
					        ),
					        array (
					            'agent' => 'NewsGatorOnline/2.0',
					            'spidername' => 'NewsGatorOnline',
					'spider' => true,
					        ),
					        array (
					            'agent' => 'ping.blo.gs/2.0',
					'spider' => true,
					        ),
					        array (
					            'agent' => 'Jakarta Commons-HttpClient/3.0.1',
					            'spidername' => 'Amazon',
					'spider' => true,
					        ),
					          array (
					            'agent' => 'Jakarta Commons-HttpClient/3.0-rc2',
					            'spidername' => 'Amazon',
					'spider' => true,
        ),		

                //mobiles
		
							 array (
										'agent' => 'Nokia',
							 ),
							 array (
										'agent' => 'Samsung',
							 ),
							 array (
										'agent' => 'Ericsson',
							 ),
							array (
										'agent' => 'Siemens',
							 ),
							  array (
										'agent' => 'Motorola',
					),
                //Browsers

 		 array (
				        'agent' => 'Playstation Portable 2.00',
				),
		                array (
				        'agent' => 'Playstation 3 1.00',
				),
		                array (
				        'agent' => 'Playstation 3 1.10',
				),
		                array (
				        'agent' => 'Playstation 3 2.00',
				),
		                array (
				'agent' => 'U',
				'name' => 'MSN Explorer',
		                ),
		
		                array (
				        'agent' => 'Firefox 0.10',
				),
		                array (
				        'agent' => 'Firefox 0.10.1',
				),
		                array (
				        'agent' => 'Firefox 0.8',
				),
		                array (
				        'agent' => 'Firefox 0.9',
				),
		                array (
				        'agent' => 'Firefox 0.9.1',
				),
		                array (
				        'agent' => 'Firefox 0.9.2',
				),
		                array (
				        'agent' => 'Firefox 0.9.3',
				),
		                array (
				        'agent' => 'Firefox 1.0',
				),
		                array (
				        'agent' => 'Firefox 1.0',
				),
		                array (
				        'agent' => 'Firefox 1.0.1',
				),
		                array (
				        'agent' => 'Firefox 1.0.2',
				),
		                array (
				        'agent' => 'Firefox 1.0.3',
				),
		                array (
				        'agent' => 'Firefox 1.0.4',
				),
		                array (
				        'agent' => 'Firefox 1.0.5',
				),
		                array (
				        'agent' => 'Firefox 1.0.6',
				),
		                array (
				        'agent' => 'Firefox 1.0.7',
				),
		                array (
				        'agent' => 'Firefox 1.0.8',
				),
		                array (
				        'agent' => 'Firefox 1.4',
				),
		                array (
				        'agent' => 'Firefox 1.4.1',
				),
		                array (
				        'agent' => 'Firefox 1.5',
				),
		                array (
				        'agent' => 'Firefox 1.5.0',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.1',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.10',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.10pre',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.11',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.2',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.2;',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.3',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.4',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.5',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.6',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.7',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.8',
				),
		                array (
				        'agent' => 'Firefox 1.5.0.9',
				),
		                array (
				        'agent' => 'Firefox 1.6a1',
				),
		                array (
				        'agent' => 'Firefox 1.9.0.1',
				),
		                array (
				        'agent' => 'Firefox 2.0',
				),
		                array (
				        'agent' => 'Firefox 2.0.0.1',
				),
		                array (
				        'agent' => 'Firefox 2.0.0.2',
				),
		                array (
				        'agent' => 'Firefox 2.0.0.2pre',
				),
		                array (
				        'agent' => 'Firefox 2.0.0.3',
				),
		                array (
				        'agent' => 'Firefox 2.0.0.3pre',
				),
		                array (
				        'agent' => 'Firefox 2.0a1',
				),
		                array (
				        'agent' => 'Firefox 2.0b',
				),
		                array (
				        'agent' => 'Firefox 2.0b1',
				),
		                array (
				        'agent' => 'Firefox 2.0b2',
				),
		                array (
				        'agent' => 'Firefox 2.0b3',
				),
		                array (
				        'agent' => 'Firefox 3.0',
				),
		                array (
				        'agent' => 'Firefox 3.0a1',
				),
		                array (
				        'agent' => 'BonEcho 0.7b1',
				),
		                array (
				        'agent' => 'BonEcho 2.0',
				),
		                array (
				        'agent' => 'BonEcho 2.0.0.1',
				),
		                array (
				        'agent' => 'BonEcho 2.0.0.1pre',
				),
		                array (
				        'agent' => 'BonEcho 2.0.0.2',
				),
		                array (
				        'agent' => 'BonEcho 2.0.0.2pre',
				),
		                array (
				        'agent' => 'BonEcho 2.0.0.3pre',
				),
		                array (
				        'agent' => 'BonEcho 2.0a2',
				),
		                array (
				        'agent' => 'BonEcho 2.0a3',
				),
		                array (
				        'agent' => 'BonEcho 2.0b1',
				),
		                array (
				        'agent' => 'BonEcho 2.0b2',
				),
		                array (
				        'agent' => 'Beonex 0.8-stable',
				),
		                array (
				        'agent' => 'Avant Browser ',
				),
		                array (
				        'agent' => 'AOL 4.0',
				),
		                array (
				        'agent' => 'AOL 5.0',
				),
		                array (
				        'agent' => 'AOL 6.0',
				),
		                array (
				        'agent' => 'AOL 7.0',
				),
		                array (
				        'agent' => 'AOL 8.0',
				),
		                array (
				        'agent' => 'AOL 9.0',
				),
		                array (
				        'agent' => 'AmigaVoyager 3.2',
				),
		                array (
				        'agent' => 'America Online Browser 1.5',
				),
		                array (
				        'agent' => 'America Online Browser 1.1',
				),
		                array (
		                        'agent' => 'Opera',
		                 ),
		                array (
		                        'agent' => 'Firefox',
		                ),
		                array (
		                        'agent' => 'Firebird',
		                ),
		                array (
		                        'agent' => 'Safari', 
		                ),
				 array (
					'agent' => 'Google Desktop',
				 ),
		                array (
		                        'agent' => 'Netscape', 
		                ),
		                array (
		                        'agent' => 'MyIE2', 
		                ),
		                
		                array (
		                        'agent' => 'Konqueror', 
		                ),
		                array (
		                        'agent' => 'Galeon', 
		                ),
		                array (
		                        'agent' => 'KMeleon',
		                ),
		
		                array (
		                        'agent' => 'NG/2.0',
		                ),
		
		                array (
		                        'agent' => 'Gecko',
		                        'name' => 'Mozilla',
		                ),
		                array (
		                        'agent' => 'MSIE',
		                          'name' => 'IE',
		
                ),

	);



foreach( $known_agents AS $poss )

		if (strpos(strtolower($user_agent), strtolower($poss['agent'])) !== false)

		{

			if ( $guest && isset($poss['spider']) && $poss['spider'] )

				$user_name = isset($poss['spidername']) ? $poss['spidername'] : (isset($poss['name']) ? $poss['name'] : $poss['agent']);

			$result = isset($poss['name']) ? $poss['name'] : $poss['agent'];

			return isset($poss['spider']) && $poss['spider'];

		}

	$result = $user_agent;

	return false;

}



?>